export type CSSProperty = Omit<keyof CSSStyleDeclaration, 'length' | 'parentRule'>;
export type CSSValue<T extends keyof CSSStyleDeclaration> = CSSStyleDeclaration[T];
export type CSSDeclaration = {
    [K in keyof CSSStyleDeclaration]?: NonNullable<CSSValue<K>>;
};
export type CSSClassName = string & {
    _CSSClassNameBrand: never;
};
export type CSSObject = CSSDeclaration;
