export { HandlerFunction } from "./dom";
import { HTMLEventName } from "./dom";
import { MaybeFuture, Observable, Observer } from "./futures";
export type JSON = string | number | boolean | null | JSONObject | JSON[];
interface JSONObject {
    [property: string]: JSON;
}
export type Handler = {
    type: string;
    handler: Promise<unknown> | Observable<unknown> | Observer<unknown> | EventListenerOrEventListenerObject;
    eventName?: HTMLEventName;
    attribute?: any;
    error?: EventListener;
    termination?: EventListener;
};
export type InlineAttributeHandler = Handler & {
    handler: JSONObject;
};
export type MaybeHandler = MaybeFuture<unknown>;
